/*
	Fog
	inputs:
	glpos			from shader glpos
	farDarkenColor
					multiplies colors
	u_farDarken	
					color for darkening, defaults to white (no effect), users can change this by adding a uniform to material
	u_farDarkenSettings;
					x = Distance offset
					y = Fade length
*/

uniform mediump vec4 u_farDarken;
uniform mediump vec4 u_farDarkenSettings;

float farDarken(vec4 glpos, float offset, float fade_length) {
	float farDarken = (1.0 - clamp((glpos.w-offset)/fade_length, 0.0, 1.0));
	return farDarken;
}

vec3 farDarkenColor(vec4 u_farDarken) {
	vec3 farDarkenColor = vec3(u_farDarken.rgb * u_farDarken.rgb * u_farDarken.rgb);
	return farDarkenColor;
}