//varying lowp vec2 v_texCoord;
//varying lowp vec2 v_texCoord2;
varying lowp vec4 v_vcolor;

uniform lowp vec4 u_color4;
uniform sampler2D u_texture;
uniform sampler2D u_texture1;

uniform mediump vec4 u_dist_strength;
uniform mediump vec4 rotation_in_x;
	
varying highp vec2 scrollUV0;

varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

varying lowp vec2 scrollUV3;

uniform highp float u_time;

/*

The strenghts of the dist_strength can be animated by animating vertex color in timelines

*/


vec2 rotate(vec2 invec, float angle, float offset){
	float rad = radians(angle);
	invec -= vec2(offset);
	invec = vec2(	invec.x*cos(rad) - invec.y*sin(rad), 
						invec.y*cos(rad) + invec.x*sin(rad));
	invec += vec2(offset);
	return invec;
}

void main()
{
	float rotation = rotation_in_x.x;
	vec2 distXY = u_dist_strength.xy * v_vcolor.xy;
	vec2 distZW = u_dist_strength.zw * v_vcolor.zw;
	//vec4 dist_strength = u_dist_strength * v_vcolor;
	vec2 distortTex1 = texture2D(u_texture1, fract(v_scrollUV1)).rg * 2.0-1.0;
	vec2 distortTex2 = texture2D(u_texture1, fract(v_scrollUV2)).rg * 2.0-1.0;
	vec4 distortMask = texture2D(u_texture1, scrollUV3);
	
	vec2 final_uv_distortion1 = distXY*distortTex1;
	vec2 final_uv_distortion2 = distZW*distortTex2;
	
	final_uv_distortion1 = rotate(final_uv_distortion1, -rotation, 0.0);
	final_uv_distortion2 = rotate(final_uv_distortion2, -rotation, 0.0);
	
	vec4 texColor = texture2D(u_texture, scrollUV0 +	((final_uv_distortion1+final_uv_distortion2) *
															distortMask.b *
															distortMask.a));
	
	gl_FragColor = texColor;
}