attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute lowp vec2 a_texCoord;
uniform lowp vec4 u_color4;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp mat4 u_modelViewMatrix;
uniform highp float u_time;
uniform mediump vec4 u_dist_tiling_scroll1;
uniform mediump vec4 u_dist_tiling_scroll2;

uniform highp vec4 uv_tiling_scroll;
varying lowp vec2 scrollUV0;

varying lowp vec4 v_ucolor;
varying lowp vec4 v_vcolor;

varying lowp vec2 v_scrollUV1;
varying lowp vec2 v_scrollUV2;

varying lowp vec2 v_texCoord;


/*

Material color red controls scrolling X axis
Material color green controls scrolling Y axis
Material color blue controls distortion strength

*/

void main()
{
	// get vertex color
	v_vcolor = a_color * u_color4;
	// store red and green channels
	vec2 color = v_vcolor.xy;
	// make red and green channels go between -1 -> 1 to be able to
	// scroll all the way through the object
	color = color*2.0-1.0;

	v_texCoord = a_texCoord;
	// scroll through the distortion map, xy adding number of tiles and zw controls speed 
	v_scrollUV1 = v_texCoord.xy*u_dist_tiling_scroll1.xy+fract(u_time*u_dist_tiling_scroll1.zw);
	v_scrollUV2 = v_texCoord.xy*u_dist_tiling_scroll2.xy+fract(u_time*u_dist_tiling_scroll2.zw);
	
	gl_Position = u_modelViewProjectionMatrix * a_position;
	

	scrollUV0.y = v_texCoord.y +color.y;
	scrollUV0.x = v_texCoord.x +color.x;
}